%define grub_name grub2
%define src_name grub2-theme
%define product virtuozzo

%if 0%{?rhel}
%global efidir redhat
%endif
%if 0%{?fedora}
%global efidir fedora
%endif
%if 0%{?centos}
%global efidir centos
%endif
%if 0%{?vzlinux}
%global efidir virtuozzo
%endif

Summary:        Provides a custom Grub2 graphical theme for Virtuozzo
Name:           %{src_name}-%{product}
Version:        1.4
Release:        1%{?dist}
License:        GPLv3+
Group:          System/Kernel and hardware
Url:            http://www.virtuozzo.com/
Source0:        %{src_name}-%{version}.tar.bz2
Requires(pre):  grub2 >= 2.02-0.17vl7.7
Provides:       grub2-theme
Conflicts:	grub2-theme-openvz
Conflicts:	grub2-theme-vzlinux
BuildArch:      noarch

%description
This package provides a custom Grub2 graphical theme for Virtuozzo.

%prep
%setup -q -n %{src_name}-%{version}

%build
PRODUCT=%{product} make

%install
mkdir -p %{buildroot}/boot/%{grub_name}/themes/virtuozzo
DATA_DIR=`PRODUCT=%{product} make list`
cp ${DATA_DIR}/* %{buildroot}/boot/%{grub_name}/themes/virtuozzo/

%post
if [ $1 -eq 1 ] ; then
# Remove previous theme-related lines from config
sed -i '/GRUB_TERMINAL_OUTPUT=*/d' %{_sysconfdir}/default/grub
sed -i '/GRUB_GFXMODE=*/d' %{_sysconfdir}/default/grub
sed -i '/GRUB_GFXPAYLOAD_LINUX=*/d' %{_sysconfdir}/default/grub
sed -i '/GRUB_THEME=*/d' %{_sysconfdir}/default/grub
sed -i '/GRUB_BACKGROUND=*/d' %{_sysconfdir}/default/grub
# Remove trailing blank lines from /etc/default/grub
sed -i -e :a -e '/^\n*$/{$d;N;};/\n$/ba' %{_sysconfdir}/default/grub
# Check that /etc/default/grub ends with a linefeed
[ "$(tail -n 1 %{_sysconfdir}/default/grub | wc --lines)" = "1" ] || echo >> %{_sysconfdir}/default/grub
# Enable GFX mode and add the theme
cat <<EOF >> %{_sysconfdir}/default/grub
GRUB_TERMINAL_OUTPUT="gfxterm"
GRUB_GFXMODE=1024x768,800x600,640x480
GRUB_GFXPAYLOAD_LINUX=keep
GRUB_THEME="/boot/%{grub_name}/themes/virtuozzo/theme.txt"
GRUB_BACKGROUND="/boot/%{grub_name}/themes/virtuozzo/terminal_background.png"
EOF
# Regenerate boot menu on install or update
%{_sbindir}/%{grub_name}-mkconfig -o /boot/%{grub_name}/grub.cfg
if [ -d /boot/efi/EFI/%{efidir} ]; then
    %{_bindir}/cp /boot/%{grub_name}/grub.cfg /boot/efi/EFI/%{efidir}/
fi
fi

%postun
exec > /var/log/%{grub_name}_theme_postun.log 2>&1
# Only if uninstalling theme
if [ $1 -eq 0 ]; then
# Remove theme from config
sed -i '/GRUB_THEME=*/d' %{_sysconfdir}/default/grub
sed -i '/GRUB_BACKGROUND=*/d' %{_sysconfdir}/default/grub
# Regenerate boot menu
%{_sbindir}/%{grub_name}-mkconfig -o /boot/%{grub_name}/grub.cfg
if [ -d /boot/efi/EFI/%{efidir} ]; then
    %{_bindir}/cp /boot/%{grub_name}/grub.cfg /boot/efi/EFI/%{efidir}/
fi
fi

%files
%dir /boot/%{grub_name}/themes/virtuozzo
/boot/%{grub_name}/themes/virtuozzo/*

%changelog
* Thu Apr 13 2017 Konstantin Vlasov <konstantin.vlasov@virtuozzo.com> 1.4-1
- Building all theme packages from one multi-product source project

* Wed Mar 29 2017 Konstantin Vlasov <konstantin.vlasov@virtuozzo.com> 1.02-1
- Improved contrast for non-selected items, #VZP-793

* Wed May 18 2016 Denis Silakov <dsilakov@virtuozzo.com> 1.01-6
- Conflict with grub2-theme-openvz

* Thu Mar 10 2016 Denis Silakov <dsilakov@virtuozzo.com> 1.01-1
- Virtuozzo rebranding

* Fri Nov 06 2015 Konstantin Vlasov <kvlasov@odin.com> 1.00-1
- Initial version
